<style src="./Style.scss" lang="scss" scoped></style>
<script src="./Script.js"></script>

<template>
  <div class="nt-dealpage">
    <div v-if="isDataLoadingSuccess" class="nt-dealpage-container">
      <div class="nt-dealpage-header nt-background-header-gradient">
        <h3 class="modal-title">
          <i class="icon icon-edit nt-dealpage-header-icon"></i>
          <span class="nt-dealpage-header-text">Sửa giao dịch</span>
        </h3>
      </div>
      <div class="nt-dealpage-content nt-dealpage-edit">
        <div
          class="m--header-collapse nt-collapse"
          v-if="accessible( userCheckAddOn, 'deal', PERMISSION_UPDATE_DEAL, userCurrentPermissions)"
        >
          <h3
            @click="switchCollapseDeal($event)"
            data-toggle="collapse"
            class="nt-collapse-header"
            href="#boxInfoDeal"
            role="button"
            aria-expanded="false"
            aria-controls="boxInfoDeal"
          >
            Thông
            tin giao dịch
          </h3>
          <button
            @click="switchCollapseDeal($event)"
            class="btn btn-sm btn-collapse nt-collapse-arrow"
            type="button"
            data-toggle="collapse"
            data-target="#boxInfoDeal"
            aria-expanded="false"
            aria-controls="boxInfoDeal"
          >
            <i class="icon icon-up-arrow-1"></i>
          </button>
        </div>
        <div
          class="nt-dealpage-content-box nt-collapse-content nt-collapse-content_attribute collapse show"
          v-if="accessible( userCheckAddOn, 'deal', PERMISSION_UPDATE_DEAL, userCurrentPermissions)"
          id="boxInfoDeal"
        >
          <div class="m-form m-form--state nt-dealpage-content-box-details">
            <attribute-with-data-type
              :attributes="listAttributesDefault"
              :server_errors="server_errors"
              :scope="'editDeal'"
              :deal="deal"
              :is_edit="true"
            ></attribute-with-data-type>
          </div>
        </div>

        <hr
          class="nt-collapse-line"
          v-if="accessible( userCheckAddOn, 'deal', PERMISSION_UPDATE_DEAL, userCurrentPermissions)"
        />
        <div
          class="m--header-collapse nt-collapse"
          v-if="accessible( userCheckAddOn, 'deal', PERMISSION_UPDATE_PRODUCT_DEAL, userCurrentPermissions)"
        >
          <h3
            @click="switchCollapseDeal($event)"
            data-toggle="collapse"
            class="nt-collapse-header"
            href="#boxInfoProducts"
            role="button"
            aria-expanded="false"
            aria-controls="boxInfoProducts"
          >Thông tin sản phẩm</h3>
          <button
            @click="switchCollapseDeal($event)"
            class="btn btn-sm btn-collapse nt-collapse-arrow"
            type="button"
            data-toggle="collapse"
            data-target="#boxInfoProducts"
            aria-expanded="false"
            aria-controls="boxInfoProducts"
          >
            <i class="icon icon-up-arrow-1"></i>
          </button>
        </div>

        <div
          class="nt-dealpage-content-box nt-collapse-content collapse show"
          id="boxInfoProducts"
          v-if="accessible( userCheckAddOn, 'deal', PERMISSION_UPDATE_PRODUCT_DEAL, userCurrentPermissions)"
        >
          <div class="m-form m-form--state">
            <div
              class="table-container nt-scroll-primary nt-table-mobile"
              :class="{'table-responsive': isScreenSmall}"
            >
              <table class="table table-bordered table-hover s--table nt-table-list">
                <thead>
                  <tr>
                    <th class="msp">Mã sản phẩm</th>
                    <th class="tsp">Tên sản phẩm</th>
                    <th class="sl text-right">Số lượng</th>
                    <th class="sl">Đơn vị</th>
                    <th class="dgny text-right">Đơn giá niêm yết</th>
                    <th class="ck text-center">
                      <select class="nt-select-discount" @change="selectTypeDiscount($event)">
                        <option
                          :selected="deal.product_discount_type == 'percent' ? true : false"
                          value="percent"
                        >CK %</option>
                        <option
                          :selected="deal.product_discount_type == 'amount' ? true : false"
                          value="amount"
                        >CK Giá trị</option>
                      </select>
                    </th>
                    <th class="dgb text-right">Đơn giá bán</th>
                    <th class="tt text-right">Thành tiền</th>
                    <th class="nsd">Người sử dụng cuối</th>
                    <th class="ttgh">Trạng thái giao hàng</th>
                    <th class="close-product"></th>
                  </tr>
                </thead>
                <tbody>
                  <tr
                    v-for="(product, product_index) in deal.products"
                    :key="product_index"
                    :class="{'disabled': product.is_disabled == 1}"
                  >
                    <template v-if="deal.products && deal.products.length > 0">
                      <td class="msp">
                        <template
                          v-if="product.product_code && product.product_code !== ''"
                        >{{product.product_code}}</template>
                      </td>
                      <td class="tsp">
                        <a
                          class="m-link m-link--primary nt-link"
                          :href="getRouteLink('productDetail', {product_id: product.id})"
                        >{{ product.product_name }}</a>

                        <!--<router-link style="color:#2577C9" target="_blank"-->
                        <!--:to="{name : 'productDetail', params : {team_id : currentTeam.team_id, product_id : product.id} }">-->
                        <!--{{product.product_name }} <i class="icon icon-external-link-01"></i>-->
                        <!--</router-link>-->
                      </td>
                      <td class="sl text-right">
                        <template v-if="product.is_add_new &&  product.product_type === 'Dịch vụ' && product.product_unit === 'Khóa'  || !product.is_add_new && product.product_type === 'Dịch vụ' && ( product.product_unit === 'Khóa' || product.product_unit === 'Buổi' || product.product_unit === 'Tháng' )">
                          <input
                            class="form-control text-right disabled"
                            v-model="product.quantity"
                            @blur="formatNumberBlur('quantity', product_index)"
                            @focus="clearFormatNumberFocus('quantity', product_index)"
                            @keyup="changeQuantityProduct(product, product_index)"
                            @keydown="setOnlyNumberInInput($event)"
                            disabled="disabled"
                          />
                        </template>
                        <template v-else>
                          <input
                            class="form-control text-right"
                            v-model="product.quantity"
                            @blur="formatNumberBlur('quantity', product_index)"
                            @focus="clearFormatNumberFocus('quantity', product_index)"
                            @keyup="changeQuantityProduct(product, product_index)"
                            @keydown="setOnlyNumberInInput($event)"
                            :disabled="product.is_disabled == 1"
                          />
                        </template>
                      </td>
                      <td class="sl">{{ product.product_unit }}</td>
                      <td class="dgny text-right">{{ product.product_price | formatNumberPrice }}</td>
                      <td class="ck text-center">
                        <input
                          v-if="deal.product_discount_type == 'percent'"
                          class="form-control text-center"
                          v-model="product.discount"
                          @keyup="changeDiscount(product, 'percent', product_index)"
                          @blur="formatNumberBlur('discount', product_index)"
                          @keydown="setOnlyNumberInInput($event)"
                          :disabled="product.is_disabled == 1"
                        />
                        <input
                          v-if="deal.product_discount_type == 'amount'"
                          class="form-control text-right"
                          v-model="product.discount"
                          @blur="formatNumberBlur('discount', product_index)"
                          @focus="clearFormatNumberFocus('discount', product_index)"
                          @keyup="changeDiscount(product, 'amount', product_index)"
                          @keydown="setOnlyNumberInInput($event)"
                          :disabled="product.is_disabled == 1"
                        />
                      </td>
                      <td class="dgb text-right">{{ product.sale_price | formatNumberPrice }}</td>
                      <td class="tt text-right">{{ product.total_price | formatNumberPrice }}</td>
                      <td class="nsd">
                        <s-custom-select
                          :data="listCustomersData"
                          :label="'customer_name'"
                          :index="'customer_id'"
                          :position_select="product_index"
                          :placeholder="'Chưa xác định'"
                          :value="product.customer"
                          :text="'khách hàng'"
                          :is_add_new="false"
                          :label_text="'Tạo mới khách hàng'"
                          :model_addnew="'#addNewCustomer'"
                          :is_search="true"
                          :return_object="true"
                          :is_deal_nsd="true"
                          :current_object="currentCustomerInDeal"
                          :buyer_deal_id="deal.customer_id"
                          :is_load_more_data="isLoadMoreData"
                          :is_edit="true"
                          :is_loading="isLoadSelect"
                          @input="customerSearch"
                          @loading_success="loadingSelectSuccess"
                          @load_more_data="loadMoreData"
                          @update_value="updateValueProductCustomer"
                          :disabled="product.is_disabled == 1"
                        >
                          <template slot="option" slot-scope="option">
                            <b
                              v-if="option.option.customer_name"
                              style="color:#444F78; font-size : 14px; font-weight: 500"
                            >
                              {{option.option.customer_name
                              | truncateWords }}
                            </b>&nbsp;
                            <span
                              style="color:#444F78; font-size : 12px; font-weight: 500"
                            >{{option.option.customer_id == deal.customer_id ? "(Người mua)" : ""}}</span>
                            <br />
                            <span
                              v-if="option.option.customer_code"
                              style="color:#A1A7BB; font-size: 14px; font-weight: 400"
                            >{{option.option.customer_code | truncateWords}}</span>
                          </template>
                        </s-custom-select>
                      </td>
                      <td class="ttgh">
                        <s-custom-select
                          :data="listProductsStatus"
                          :label="'name'"
                          :index="'id'"
                          :position_select="'status-' + product_index"
                          :value.sync="product.status"
                          :text="'trạng thái'"
                          :disabled="product.is_disabled == 1"
                        ></s-custom-select>
                      </td>
                      <td class="close-product text-center">
                        <a
                          href="javascript:;"
                          @click="closeProductFromTable(product.sort_order)"
                          class="close-product"
                        >
                          <i class="fa fa-times"></i>
                        </a>
                      </td>
                    </template>
                  </tr>
                  <tr>
                    <td></td>
                    <td>
                      <s-custom-select
                        v-if="isLoadProduct"
                        :data="listProducts"
                        :label="'product_name'"
                        :index="'id'"
                        :position_select="'add-new-product'"
                        :value.sync="productSelected"
                        :text="'sản phẩm'"
                        :is_search="true"
                        :placeholder="'Tìm kiếm và chọn sản phẩm'"
                        :save_change="false"
                        @change="selectProductInDeal"
                      ></s-custom-select>
                    </td>
                    <td></td>
                    <td></td>
                    <td></td>
                    <td></td>
                    <td></td>
                    <td></td>
                    <td></td>
                    <td></td>
                    <td></td>
                  </tr>
                </tbody>
              </table>
            </div>
            <div class="m-form m-form--state">
              <div class="row" style="margin:0px">
                <div class="col-md-6 form-group m-form__group">
                  <div
                    class="col-md-6 form-group m-form__group"
                    :class="{'has-danger' : errors.has('editDeal.order_note')}"
                  >
                    <label for="order_note" class="form-control-label s--label nt-label">
                      Ghi
                      chú
                    </label>
                    <textarea
                      id="order_note"
                      v-model="noteDeal"
                      v-validate="{max : 1025}"
                      placeholder="Điền ghi chú cho đơn hàng"
                      :data-vv-scope="'editDeal'"
                      name="order_note"
                      style="height:123px;"
                      class="form-control"
                    ></textarea>
                    <div
                      class="form-control-feedback m--font-danger"
                      v-if="errors.has('editDeal.order_note')"
                    >
                      {{
                      errors.first('editDeal.order_note') }}
                    </div>
                    <div
                      class="form-control-feedback m--font-danger"
                      v-else-if="!errors.has('editDeal.order_note')"
                    >&nbsp;</div>
                  </div>
                </div>
                <div class="col-md-6 form-group m-form__group">
                  <div class="col-md-6 pull-right form-group m-form__group">
                    <div class="total-amount">
                      <label class="form-control-label s--label nt-label">Tổng thành tiền:</label>
                      <label class="pull-right form-control-label s--label nt-label">
                        {{deal.total
                        |
                        formatNumberPrice}}
                      </label>
                    </div>
                    <div class="additional_discount">
                      <label class="form-control-label s--label nt-label">Chiết khấu thêm:</label>
                      <div style="display:inline-block; width:100%;">
                        <select
                          class="form-control pull-left col-md-3"
                          @change="selectTypeAdditionalDiscount($event)"
                        >
                          <option
                            :selected="deal.discount.type == 'percent' ? true : false"
                            value="percent"
                          >%</option>
                          <option
                            :selected="deal.discount.type == 'amount' ? true : false"
                            value="amount"
                          >Giá trị</option>
                        </select>
                        <input
                          v-if="deal.discount.type == 'percent'"
                          class="nt-deal-discount form-control text-center pull-left col-md-3"
                          v-model="deal.discount.value"
                          @blur="formatNumberBlur('addDiscount')"
                          @keyup="changeAdditionalDiscount('percent')"
                          @keydown="setOnlyNumberInInput($event)"
                        />
                        <input
                          v-if="deal.discount.type == 'amount'"
                          class="nt-deal-discount form-control pull-left col-md-3 text-right"
                          @blur="formatNumberBlur('addDiscount')"
                          @focus="clearFormatNumberFocus('addDiscount')"
                          v-model="deal.discount.value"
                          @keyup="changeAdditionalDiscount('amount')"
                          @keydown="setOnlyNumberInInput($event)"
                        />
                        <label
                          class="pull-right form-control-label s--label nt-label"
                          style="display: flex;
                                                       align-items: center;
                                                       justify-content: flex-end;
                                                       width: calc(41% - 14px);
                                                       height: 40px;
                                                       margin-left : 8px;
                                                       margin-bottom :0px;"
                        >
                          <template v-if="deal.discount.total_discount > 0">-</template>
                          {{deal.discount.total_discount | formatNumberPrice}}
                        </label>
                      </div>
                    </div>
                    <hr />
                    <div class="deal_vat">
                      <label class="form-control-label s--label nt-label">VAT:</label>
                      <div style="display:inline-block; width:100%;">
                        <select
                          v-if="listVAT && listVAT.length > 0"
                          v-model="deal.vat_type"
                          class="form-control pull-left col-md-3"
                        >
                          <option
                            v-for="(vat, index) in listVAT"
                            :value="vat.id"
                            :key="index"
                          >{{vat.option_value}}</option>
                        </select>
                        <label
                          class="pull-right form-control-label s--label nt-label"
                          style="display: flex;
                                                       align-items: center;
                                                       justify-content: flex-end;
                                                       width: calc(41% - 14px);
                                                       height: 40px;
                                                       margin-left : 8px;
                                                       margin-bottom :0px;"
                        >{{deal.vat_amount| formatNumberPrice}}</label>
                      </div>
                    </div>
                    <hr />
                    <div class="total_transaction_amount">
                      <label class="form-control-label s--label nt-label" style="margin-top:7px;">
                        Tổng
                        thanh toán:
                      </label>
                      <label
                        class="pull-right form-control-label s--label nt-label"
                        style="font-size:20px !important;"
                      >
                        {{deal.total_after_discount
                        | formatNumberPrice}}
                      </label>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <hr
          class="nt-collapse-line"
          v-if="accessible( userCheckAddOn, 'deal', PERMISSION_UPDATE_PRODUCT_DEAL, userCurrentPermissions)"
        />
        <div
          class="m--header-collapse nt-collapse"
          v-if="accessible( userCheckAddOn, 'deal', PERMISSION_UPDATE_DEAL_EXTRA, userCurrentPermissions)"
        >
          <h3
            @click="switchCollapseDeal($event)"
            data-toggle="collapse"
            class="nt-collapse-header"
            href="#boxInfoExtendDeal"
            role="button"
            aria-expanded="false"
            aria-controls="boxInfoExtendDeal"
          >Thông tin mở rộng</h3>
          <button
            @click="switchCollapseDeal($event)"
            class="btn btn-sm btn-collapse nt-collapse-arrow"
            type="button"
            data-toggle="collapse"
            data-target="#boxInfoExtendDeal"
            aria-expanded="false"
            aria-controls="boxInfoExtendDeal"
          >
            <i class="icon icon-up-arrow-1"></i>
          </button>
        </div>
        <div
          class="nt-dealpage-content-box nt-collapse-content nt-collapse-content_attribute collapse show"
          v-if="accessible( userCheckAddOn, 'deal', PERMISSION_UPDATE_DEAL_EXTRA, userCurrentPermissions)"
          id="boxInfoExtendDeal"
        >
          <div class="m-form m-form--state nt-dealpage-content-box-details">
            <attribute-with-data-type
              :attributes="listAttributesExtend"
              :server_errors="server_errors"
              :scope="'editDeal'"
              :extend="true"
              :deal="deal"
              :is_edit="true"
            ></attribute-with-data-type>
          </div>
        </div>
      </div>
      <div class="nt-dealpage-footer">
        <button
          type="button"
          @click="reset()"
          class="btn-link nt-button nt-button-secondary"
          data-dismiss="modal"
        >Hủy bỏ</button>
        <button
          type="submit"
          :class="{'nt-button-disabled' : !isChange || errors.any()}"
          :disabled="!isChange || errors.any()"
          @click="updateDeal()"
          class="nt-button nt-button-warning"
        >Cập nhật</button>
      </div>
      <add-new-customer @add_new_success="afterCreateSuccess()"></add-new-customer>
    </div>
    <div v-else class="nt-dealpage-backdrop">
      <div
        class="m-loader m-loader--brand m-loader--lg"
        style="width: 30px; height: 30px; display: inline-block; position:absolute; top:50%; left: 50%; transform: translate(-50%, -50%)"
      ></div>
    </div>
    <div v-if="isLoader" class="nt-dealpage-backdrop">
      <div
        class="m-loader m-loader--brand m-loader--lg"
        style="width: 30px; height: 30px; display: inline-block; position:absolute; top:50%; left: 50%; transform: translate(-50%, -50%)"
      ></div>
    </div>
    <div
      data-backdrop="static"
      data-keyboard="false"
      class="modal s--modal fade nt--modal-confirm-choice"
      id="policyErrors"
    >
      <div class="modal-dialog">
        <div class="modal-content" id="popup-add-on">
          <div class="modal-body">
            <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
            <!--Thông báo-->
            <!--</h3>-->
            <div class="nt--modal-confirm-choice-content">
              <div class="nt--modal-confirm-choice-content-title-top">
                Giao dịch đã bị hủy bỏ hoặc hoàn thành.
                <br />Vui lòng chuyển về trang chi tiết giao dịch.
              </div>
            </div>
          </div>

          <div class="modal-footer">
            <button
              class="nt-button nt-button-warning mr-0"
              @click="redirectToDetail()"
              data-dismiss="modal"
              aria-label="Close"
            >Đóng</button>
          </div>
        </div>
      </div>
    </div>
    <div
      data-backdrop="static"
      data-keyboard="false"
      class="modal s--modal fade nt--modal-confirm-choice"
      id="policyErrorsEdu"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-body">
            <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
            <!--Thông báo-->
            <!--</h3>-->
            <div class="nt--modal-confirm-choice-content">
              <div class="nt--modal-confirm-choice-content-title-top">
                Người dùng đã được xếp vào lớp học.
                <br />Không thể chỉnh sửa trạng thái giao dịch.
                <br />Vui lòng tải lại trang.
              </div>
            </div>
          </div>

          <div class="modal-footer">
            <button
              class="nt-button nt-button-warning mr-0"
              @click="refreshPage()"
              data-dismiss="modal"
              aria-label="Close"
            >Đóng</button>
          </div>
        </div>
      </div>
    </div>
    <div
      data-backdrop="static"
      data-keyboard="false"
      class="modal s--modal fade nt--modal-confirm-choice"
      id="server_change_data"
    >
      <div class="modal-dialog" style="max-width: 600px;">
        <div class="modal-content">
          <div class="modal-body">
            <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
            <!--Thông báo-->
            <!--</h3>-->
            <div class="nt--modal-confirm-choice-content">
              <div class="nt--modal-confirm-choice-content-title-top">
                Dữ liệu thay đổi
                <br />Vui lòng tải lại trang
              </div>
            </div>
          </div>

          <div class="modal-footer">
            <button
              class="nt-button nt-button-warning mr-0"
              data-dismiss="modal"
              aria-label="Close"
              @click.prevent="reloadPage()"
            >Đóng</button>
          </div>
        </div>
      </div>
    </div>
    <message-change-data></message-change-data>
  </div>
</template>
